(*
  version: 0.8
  mailto: gpsupport@f-m.fm

  Copyright  2007, Alex. Shyshko
*)

unit KOLComboBoxEx;

interface

uses Windows, Messages, KOL;

type

  PSAComboBoxEx = ^TSAComboBoxEx;
  TSAComboBoxEx = object(TControl)

  private
   procedure SetImageList (IL: PImageLIst);
   procedure SetOffset (Val: integer);

   function NewOnDrawItem(Sender: PObj; DC: HDC; const Rect: TRect;
      ItemIdx: Integer; DrawAction: TDrawAction; ItemState: TDrawState): Boolean;

  public

    property ImageList : PImageList write SetImageList;

    property TextOffsetLeft : integer write SetOffset;
    property OnDrawItem: Boolean read FNotAvailable;
    property OnPaint: Boolean read FNotAvailable;

  end;

  TkolSAComboBoxEx = PSAComboBoxEx;

  PData = ^TData;
  TData = Record
    IL: PImageList;
    TextOffsetLeft: integer;

  end;


function NewSAComboBoxEx(ASender: PControl; Options: TComboOptions): PSAComboBoxEx;



implementation


procedure TSAComboBoxEx.SetOffset;
begin

Pdata(CustomData).TextOffsetLeft:=Val;

end;

procedure TSAComboBoxEx.SetImageList;
begin

Pdata(CustomData).IL:= IL;

end;

function TSAComboBoxEx.NewOnDrawItem;
var
  cbRect: TRect;
  D: PData;
begin
  Result:=true;
  if ItemIdx >= 0 then
  begin
  D := Pointer(CustomData);
  //  -  ,        .
  SetBkMode(DC, Self.Font.Color);

  //     
  if (odsSelected in ItemState) then Self.Canvas.Brush.Color := clHighlight
  else Self.Canvas.Brush.Color:= Self.Color;

  FillRect(DC, Rect, Self.Canvas.Brush.Handle);


  cbRect := Rect;
  cbRect.Left := 25 + d.TextOffsetLeft;

  DrawText(DC, PChar(Items[ItemIdx]), -1, cbRect, DT_SINGLELINE or DT_VCENTER or DT_NOPREFIX);

   //== Icon 16x16
  if (odsComboboxEdit in ItemState) then
  begin // Edit
    cbRect.Top := 5;
    cbRect.Bottom := 21;
    cbRect.Left := 4;
    cbRect.Right := 20;
  end else
  begin // DropList
    cbRect.Left := 2;
    cbRect.Right := 18;
    cbrect.Bottom:= cbRect.Top + 16;

  end;
  // 
  if D.IL <> nil then
   if d.IL.Count > ItemIdx then
   d.IL.StretchDraw(ItemIdx,dc, cbRect);

  end;
end;


function NewSAComboBoxEx;
var
  D: PData;
begin
  Result := PSAComboBoxEx(NewCombobox(ASender, [coReadOnly, coOwnerDrawFixed] + Options));

  // init data field
  GetMem(D, SizeOf(d^));
  ZeroMemory(D,SizeOf(d^));
  Result.CustomData := D;

  Result.SetOnDrawItem(Result.NewOnDrawItem);

end;

end.