(*
  version: 0.8
  mailto: gpsupport@f-m.fm

  Copyright  2007, Alex. Shyshko
*)

unit MCKComboBoxEx;

interface

uses Windows, Messages, Classes, Controls, mirror, mckCtrls, mckObjs, Graphics,KOLComboBoxEx,KOL;

type
  TkolSAComboBoxEx = class(TKOLComboBox)
  private
    FNotAvailable: Boolean;



    FImageList: TKolImageList;
    FOptions: TComboOptions;

    procedure SetOptions(const Value: TComboOptions);

    procedure SetImageList(const Value: TKolImageList);

  protected
    function TypeName: String; override;
    function AdditionalUnits: string; override;
    procedure SetupConstruct( SL: TStringList; const AName, AParent, Prefix: String ); override;
    function SetupParams( const AName, AParent: String ): String; override;
    procedure SetupFirst( SL: TStringList; const AName, AParent, Prefix: String ); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published


    property ImageList: TKolImageList read FImageList write SetImageList;
    property Options: TComboOptions read FOptions write SetOptions;

    //==    < >
    property Caption: Boolean read FNotAvailable;
    property OnDrawItem: Boolean read FNotAvailable;
    property OnPaint: Boolean read FNotAvailable;

  end;

procedure Register;

implementation


procedure Register;
begin
  RegisterComponents( 'KOL Add', [TkolSAComboBoxEx]);
end;


function TkolSAComboBoxEx.AdditionalUnits: string;
begin
    Result := ', KOLComboBoxEx';
end;

function TkolSAComboBoxEx.TypeName: String;
begin
  Result := 'SAComboBoxEx';
end;

procedure TkolSAComboBoxEx.SetupConstruct(SL: TStringList; const AName, AParent, Prefix: String);
begin
    SL.Add( Prefix + AName + ' := PSAComboBoxEx( New' + TypeName + '( ' + SetupParams( AName, AParent ) + ' )' + GenerateTransparentInits + ');');

end;

function TkolSAComboBoxEx.SetupParams(const AName, AParent: String): String;
var s: string;
begin
  if coReadOnly in Options then
    S := S + 'coReadOnly';
  if coNoHScroll in Options then
    S := S + ', coNoHScroll';
  if coAlwaysVScroll in Options then
    S := S + ', coAlwaysVScroll';
  if coLowerCase in Options then
    S := S + ', coLowerCase';
  if coNoIntegralHeight in Options then
    S := S + ', coNoIntegralHeight';
  if coOemConvert in Options then
    S := S + ', coOemConvert';
  if coSort in Options then
    S := S + ', coSort';
  if coUpperCase in Options then
    S := S + ', coUpperCase';
  if coOwnerDrawFixed in Options then
    S := S + ', coOwnerDrawFixed';
  if coOwnerDrawVariable in Options then
    S := S + ', coOwnerDrawVariable';
  if coSimple in Options then
    S := S + ', coSimple';
  if S <> '' then
  if S[ 1 ] = ',' then
    S := Copy( S, 3, MaxInt );

  Result := AParent + ', [ ' + S + ' ]';

end;

constructor TkolSAComboBoxEx.Create(AOwner: TComponent);
begin
    inherited;

    ImageList:= nil;
    FOptions:=[coNoIntegralHeight];
end;

destructor TkolSAComboBoxEx.Destroy;
begin

  inherited;
end;

procedure TkolSAComboBoxEx.SetImageList(const Value: TKolImageList);
begin
    FImageList := Value;
    Change;
end;



procedure TkolSAComboBoxEx.SetOptions;
begin
 FOptions:=Value;
 change;
end;


procedure TkolSAComboBoxEx.SetupFirst(SL: TStringList; const AName, AParent, Prefix: String);
var
    S: String;
begin
  inherited;

    if ImageList <> nil then begin
      if ImageList.ParentFORM.Name = ParentForm.Name then S:= 'Result.' + ImageList.Name
      else S:= ImageList.ParentFORM.Name +'.'+ ImageList.Name;

      SL.Add(Prefix + AName + '.ImageList:= ' + S + ';');
    end;

end;

end.

